open Sml;;

open Format;;

let rec lexem ppf = function
  | Text t -> pp_print_string ppf t
  | Space c -> pp_print_char ppf c
  | Open tag -> fprintf ppf "<%a>" tag_type tag
  | Close tag -> fprintf ppf "</%a>" tag_type tag

and tag_type ppf = function
  | U -> pp_print_char ppf 'U'
  | S -> pp_print_char ppf 'S'
  | EM -> pp_print_string ppf "EM"
  | I -> pp_print_char ppf 'I'
  | B -> pp_print_char ppf 'B'
  | TT -> pp_print_string ppf "TT"
  | PL -> pp_print_string ppf "PL"
  | SZ i -> pp_print_int ppf i
  | Color c -> color ppf c

and color ppf = function
  | Red -> pp_print_char ppf 'r'
  | Green -> pp_print_char ppf 'g'
  | Blue -> pp_print_char ppf 'b'
  | Cyan -> pp_print_char ppf 'c'
  | Magenta -> pp_print_char ppf 'm'
  | Yellow -> pp_print_char ppf 'y'
  | Black -> pp_print_char ppf 'k'
  | White -> pp_print_char ppf 'w'
  | Initial -> assert false;;
